Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
Botan::XMSS_WOTS_Addressed_PublicKey Class Reference

`#include <xmss_wots_addressed_publickey.h>`

Inheritance diagram for Botan::XMSS_WOTS_Addressed_PublicKey:

## Public Member Functions
const XMSS_Address & | address () const
XMSS_Address & | address ()
virtual std::string | algo_name () const override
virtual AlgorithmIdentifier | algorithm_identifier () const override
virtual bool | check_key (RandomNumberGenerator &rng, bool strong) const override
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual size_t | estimated_strength () const override
virtual OID | get_oid () const override
virtual size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
const XMSS_WOTS_PublicKey & | public_key () const
XMSS_WOTS_PublicKey & | public_key ()
virtual std::vector< uint8_t > | public_key_bits () const override
std::vector< uint8_t > | subject_public_key () const
| XMSS_WOTS_Addressed_PublicKey (const XMSS_WOTS_PublicKey &public_key)
| XMSS_WOTS_Addressed_PublicKey (const XMSS_WOTS_PublicKey &public_key, const XMSS_Address &adrs)
| XMSS_WOTS_Addressed_PublicKey (XMSS_WOTS_PublicKey &&public_key)
| XMSS_WOTS_Addressed_PublicKey (XMSS_WOTS_PublicKey &&public_key, XMSS_Address &&adrs)

## Protected Attributes
XMSS_Address | m_adrs
XMSS_WOTS_PublicKey | m_pub_key

## Detailed Description

Wrapper class to pair a XMSS_WOTS_PublicKey with an XMSS Address. Since the PK_Ops::Verification interface does not allow an extra address parameter to be passed to the sign(RandomNumberGenerator&), the address needs to be stored together with the key and passed to the XMSS_WOTS_Verification_Operation() on creation.

Definition at line 24 of file xmss_wots_addressed_publickey.h.

## Constructor & Destructor Documentation

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | const XMSS_WOTS_PublicKey & | public_key | ) |
| inline

Definition at line 27 of file xmss_wots_addressed_publickey.h.

28 : m_pub_key(public_key), m_adrs() {}
Botan::XMSS_WOTS_Addressed_PublicKey::public_key
const XMSS_WOTS_PublicKey & public_key() const
Definition: xmss_wots_addressed_publickey.h:41
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:92
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | const XMSS_WOTS_PublicKey & | public_key,
|  | const XMSS_Address & | adrs
| ) |  |
| inline

Definition at line 30 of file xmss_wots_addressed_publickey.h.

32 : m_pub_key(public_key), m_adrs(adrs) {}
Botan::XMSS_WOTS_Addressed_PublicKey::public_key
const XMSS_WOTS_PublicKey & public_key() const
Definition: xmss_wots_addressed_publickey.h:41
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:92
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | XMSS_WOTS_PublicKey && | public_key | ) |
| inline

Definition at line 34 of file xmss_wots_addressed_publickey.h.

35 : m_pub_key(std::move(public_key)), m_adrs() {}
Botan::XMSS_WOTS_Addressed_PublicKey::public_key
const XMSS_WOTS_PublicKey & public_key() const
Definition: xmss_wots_addressed_publickey.h:41
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:92
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

Botan::XMSS_WOTS_Addressed_PublicKey::XMSS_WOTS_Addressed_PublicKey | ( | XMSS_WOTS_PublicKey && | public_key,
|  | XMSS_Address && | adrs
| ) |  |
| inline

Definition at line 37 of file xmss_wots_addressed_publickey.h.

39 : m_pub_key(std::move(public_key)), m_adrs(std::move(adrs)) {}
Botan::XMSS_WOTS_Addressed_PublicKey::public_key
const XMSS_WOTS_PublicKey & public_key() const
Definition: xmss_wots_addressed_publickey.h:41
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:92
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

## Member Function Documentation

const XMSS_Address& Botan::XMSS_WOTS_Addressed_PublicKey::address | ( |  | ) | const
| inline

Definition at line 44 of file xmss_wots_addressed_publickey.h.

References m_adrs.

Referenced by Botan::XMSS_WOTS_Verification_Operation::is_valid_signature(), and Botan::XMSS_WOTS_Signature_Operation::sign().

44 { return m_adrs; }
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:92

XMSS_Address& Botan::XMSS_WOTS_Addressed_PublicKey::address | ( |  | ) |
| inline

Definition at line 45 of file xmss_wots_addressed_publickey.h.

References m_adrs.

45 { return m_adrs; }
Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
XMSS_Address m_adrs
Definition: xmss_wots_addressed_publickey.h:92

virtual std::string Botan::XMSS_WOTS_Addressed_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 47 of file xmss_wots_addressed_publickey.h.

References Botan::XMSS_WOTS_PublicKey::algo_name(), and m_pub_key.

48 {
49 return m_pub_key.algo_name();
50 }
Botan::XMSS_WOTS_PublicKey::algo_name
virtual std::string algo_name() const override
Definition: xmss_wots_publickey.h:234
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

virtual AlgorithmIdentifier Botan::XMSS_WOTS_Addressed_PublicKey::algorithm_identifier | ( |  | ) | const
| inline override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 52 of file xmss_wots_addressed_publickey.h.

References Botan::XMSS_WOTS_PublicKey::algorithm_identifier(), and m_pub_key.

53 {
54 return m_pub_key.algorithm_identifier();
55 }
Botan::XMSS_WOTS_PublicKey::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const override
Definition: xmss_wots_publickey.h:239
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

virtual bool Botan::XMSS_WOTS_Addressed_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| inline override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Definition at line 57 of file xmss_wots_addressed_publickey.h.

References Botan::XMSS_WOTS_PublicKey::check_key(), and m_pub_key.

59 {
60 return m_pub_key.check_key(rng, strong);
61 }
Botan::XMSS_WOTS_PublicKey::check_key
virtual bool check_key(RandomNumberGenerator &, bool) const override
Definition: xmss_wots_publickey.h:244
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::ElGamal_PublicKey.

Definition at line 79 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

82 {
83 throw Lookup_Error(algo_name() + " does not support encryption");
84 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::RSA_PublicKey, and Botan::McEliece_PublicKey.

Definition at line 87 of file pk_keys.cpp.

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

90 {
91 throw Lookup_Error(algo_name() + " does not support KEM encryption");
92 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

virtual std::unique_ptr<PK_Ops::Verification> Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| inline override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 64 of file xmss_wots_addressed_publickey.h.

References Botan::XMSS_WOTS_PublicKey::create_verification_op(), and m_pub_key.

66 {
67 return m_pub_key.create_verification_op(params, provider);
68 }
Botan::XMSS_WOTS_PublicKey::create_verification_op
virtual std::unique_ptr< PK_Ops::Verification > create_verification_op(const std::string &, const std::string &provider) const override
Definition: xmss_wots_publickey.cpp:68
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

virtual size_t Botan::XMSS_WOTS_Addressed_PublicKey::estimated_strength | ( |  | ) | const
| inline override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 75 of file xmss_wots_addressed_publickey.h.

References Botan::XMSS_WOTS_PublicKey::estimated_strength(), and m_pub_key.

76 {
77 return m_pub_key.estimated_strength();
78 }
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91
Botan::XMSS_WOTS_PublicKey::estimated_strength
virtual size_t estimated_strength() const override
Definition: xmss_wots_publickey.h:253

virtual OID Botan::XMSS_WOTS_Addressed_PublicKey::get_oid | ( |  | ) | const
| inline override virtual

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented from Botan::Public_Key.

Definition at line 70 of file xmss_wots_addressed_publickey.h.

References Botan::Public_Key::get_oid(), and m_pub_key.

71 {
72 return m_pub_key.get_oid();
73 }
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:30
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

virtual size_t Botan::XMSS_WOTS_Addressed_PublicKey::key_length | ( |  | ) | const
| inline override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 80 of file xmss_wots_addressed_publickey.h.

References Botan::XMSS_WOTS_PublicKey::estimated_strength(), and m_pub_key.

81 {
82 return m_pub_key.estimated_strength();
83 }
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91
Botan::XMSS_WOTS_PublicKey::estimated_strength
virtual size_t estimated_strength() const override
Definition: xmss_wots_publickey.h:253

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 114 of file pk_keys.h.

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

114 { return 0; }

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::GOST_3410_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, and Botan::DSA_PublicKey.

Definition at line 103 of file pk_keys.h.

Referenced by Botan::X509_Object::check_signature(), Botan::choose_sig_format(), Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

103 { return 1; }

const XMSS_WOTS_PublicKey& Botan::XMSS_WOTS_Addressed_PublicKey::public_key | ( |  | ) | const
| inline

Definition at line 41 of file xmss_wots_addressed_publickey.h.

References m_pub_key.

Referenced by Botan::XMSS_WOTS_Verification_Operation::is_valid_signature(), Botan::XMSS_WOTS_Verification_Operation::update(), and Botan::XMSS_WOTS_Verification_Operation::XMSS_WOTS_Verification_Operation().

41 { return m_pub_key; }
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

XMSS_WOTS_PublicKey& Botan::XMSS_WOTS_Addressed_PublicKey::public_key | ( |  | ) |
| inline

Definition at line 42 of file xmss_wots_addressed_publickey.h.

References m_pub_key.

42 { return m_pub_key; }
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

virtual std::vector<uint8_t> Botan::XMSS_WOTS_Addressed_PublicKey::public_key_bits | ( |  | ) | const
| inline override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 85 of file xmss_wots_addressed_publickey.h.

References m_pub_key, and Botan::XMSS_WOTS_PublicKey::public_key_bits().

86 {
87 return m_pub_key.public_key_bits();
88 }
Botan::XMSS_WOTS_PublicKey::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const override
Definition: xmss_wots_publickey.h:263
Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
XMSS_WOTS_PublicKey m_pub_key
Definition: xmss_wots_addressed_publickey.h:91

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 17 of file pk_keys.cpp.

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents_unlocked(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), and Botan::X509::PEM_encode().

18 {
19 return DER_Encoder()
20 .start_cons(SEQUENCE)
21 .encode(algorithm_identifier())
22 .encode(public_key_bits(), BIT_STRING)
23 .end_cons()
24 .get_contents_unlocked();
25 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::SEQUENCE
Definition: asn1_obj.h:39
Botan::BIT_STRING
Definition: asn1_obj.h:34

## Member Data Documentation

XMSS_Address Botan::XMSS_WOTS_Addressed_PublicKey::m_adrs
| protected

Definition at line 92 of file xmss_wots_addressed_publickey.h.

Referenced by address().

XMSS_WOTS_PublicKey Botan::XMSS_WOTS_Addressed_PublicKey::m_pub_key
| protected

Definition at line 91 of file xmss_wots_addressed_publickey.h.

Referenced by algo_name(), algorithm_identifier(), check_key(), create_verification_op(), estimated_strength(), get_oid(), key_length(), public_key(), and public_key_bits().

The documentation for this class was generated from the following file:

- src/lib/pubkey/xmss/xmss_wots_addressed_publickey.h